diff --git a/cdist/conf/type/__package/explorer/pkgng_exists b/cdist/conf/type/__package/explorer/pkgng_exists
new file mode 100755
index 00000000..7c4f2256
--- /dev/null
+++ b/cdist/conf/type/__package/explorer/pkgng_exists
@@ -0,0 +1,31 @@
+#!/bin/sh
+#
+# 2014 Jake Guffey (jake.guffey at eprotex.com)
+#
+# This file is part of cdist.
+#
+# cdist is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# cdist is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with cdist. If not, see .
+#
+#
+# Retrieve the status of a package - parsed dpkg output
+#
+
+if [ "$(cat "$__global/explorer/os")" = "freebsd" ]; then
+ if command -v pkg >&-; then
+ printf "pkg-ng installed"
+ else
+ printf "pkg-ng not found"
+ fi
+fi
+
diff --git a/cdist/conf/type/__package/manifest b/cdist/conf/type/__package/manifest
index 0ebf0099..2e085158 100755
--- a/cdist/conf/type/__package/manifest
+++ b/cdist/conf/type/__package/manifest
@@ -33,7 +33,14 @@ else
amazon|centos|fedora|redhat) type="yum" ;;
archlinux) type="pacman" ;;
debian|ubuntu) type="apt" ;;
- freebsd) type="pkg_freebsd" ;;
+ freebsd)
+ exists="$(cat "$__object/explorer/pkgng_exists")"
+ if [ "$exists" = "pkg-ng installed" ]; then
+ type="pkgng_freebsd"
+ else
+ type="pkg_freebsd"
+ fi
+ ;;
gentoo) type="emerge" ;;
suse) type="zypper" ;;
openwrt) type="opkg" ;;
diff --git a/cdist/conf/type/__package_pkgng_freebsd/explorer/pkg_version b/cdist/conf/type/__package_pkgng_freebsd/explorer/pkg_version
new file mode 100755
index 00000000..fe940724
--- /dev/null
+++ b/cdist/conf/type/__package_pkgng_freebsd/explorer/pkg_version
@@ -0,0 +1,37 @@
+#!/bin/sh
+#
+# 2012 Jake Guffey (jake.guffey at eprotex.com)
+#
+# This file is part of cdist.
+#
+# cdist is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# cdist is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with cdist. If not, see .
+#
+#
+# Retrieve the status of a package - parsed dpkg output
+#
+
+if [ -f "$__object/parameter/name" ]; then
+ name="$(cat "$__object/parameter/name")"
+else
+ name="$__object_id"
+fi
+
+# Don't produce "no pkgs installed" output -- breaks things
+PKG_OUTPUT=$(pkg info 2>&1)
+echo -n "$(echo "$PKG_OUTPUT" \
+ | awk '{print $1}' \
+ | sed 's/^\(.*\)-\([^-]*\)$/name:\1 ver:\2/g' \
+ | grep "name:$name ver:" \
+ | sed 's/^.*ver:\(.*\)/\1/g')"
+
diff --git a/cdist/conf/type/__package_pkgng_freebsd/gencode-remote b/cdist/conf/type/__package_pkgng_freebsd/gencode-remote
new file mode 100755
index 00000000..36af987b
--- /dev/null
+++ b/cdist/conf/type/__package_pkgng_freebsd/gencode-remote
@@ -0,0 +1,134 @@
+#!/bin/sh
+#
+# 2012 Jake Guffey (jake.guffey at eprotex.com)
+#
+# This file is part of cdist.
+#
+# cdist is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# cdist is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with cdist. If not, see .
+#
+#
+# Manage packages with pkg on FreeBSD
+#
+
+# Debug
+#exec >&2
+#set -x
+
+if [ -f "$__object/parameter/name" ]; then
+ name="$(cat "$__object/parameter/name")"
+else
+ name="$__object_id"
+fi
+
+if [ -f "$__object/parameter/flavor" ]; then
+ flavor="$(cat "$__object/parameter/flavor")"
+fi
+
+if [ -f "$__object/parameter/version" ]; then
+ version="$(cat "$__object/parameter/version")"
+fi
+
+if [ -f "$__object/parameter/upgrade" ]; then
+ upgrade="true"
+else
+ upgrade="false"
+fi
+
+if [ -f "$__object/parameter/repo" ]; then
+ repo="$(cat "$__object/parameter/repo")"
+fi
+
+if [ -f "$__object/parameter/state" ]; then
+ state="$(cat "$__object/parameter/state")"
+else
+ state="present"
+fi
+curr_version="$(cat "$__object/explorer/pkg_version")"
+add_cmd="pkg install -y"
+rm_cmd="pkg delete -y"
+upg_cmd="pkg upgrade -y"
+cmd=""
+
+# Print the command to be executed
+# Parms: $1 -- mode, "rm", "add", or "upg"
+# $2 -- the command to be echoed
+execcmd(){
+ local _cmd=""
+
+ case "$1" in
+ add)
+ _cmd="${add_cmd} $2"
+ ;;
+ rm)
+ _cmd="${rm_cmd} $2"
+ ;;
+ upg)
+ _cmd="${upg_cmd} $2"
+ ;;
+ *)
+ printf "Error. Don't understand command: %s" "$1" >&2
+ exit 1
+ ;;
+ esac
+
+ echo "$_cmd 2>&- >&-" # Silence the output of the command
+ echo "status=\$?"
+ echo "if [ \"\$status\" -ne \"0\" ]; then"
+ echo " echo \"Error: ${_cmd} exited nonzero with \$status\"'!' >&2"
+ echo " exit 1"
+ echo "fi"
+}
+
+if [ -n "$curr_version" ]; then # PKG *is* installed
+ if [ -n "$repo" ]; then
+ cmd="-r ${repo} ${name}"
+ else
+ cmd="${name}"
+ fi
+ if [ -n "$flavor" ]; then
+ cmd="${cmd}-${flavor}"
+ fi
+ if [ "$state" = "absent" ]; then
+ execcmd "rm" "${cmd}"
+ elif [ "$version" != "$curr_version" ]; then
+ if [ "$upgrade" = "true" ]; then
+ execcmd "upg" "${cmd}"
+ else
+ printf "Version %s is already installed and pkg-ng can't upgrade directly to version %s.\nTo upgrade to the latest version, use the --upgrade flag.\n" "$curr_version" "$version" >&2
+ exit 1
+ fi
+ fi
+else # PKG *isn't* installed
+ if [ "$state" = "absent" ]; then # Shouldn't be installed
+ exit 0
+ else # Should be installed
+ if [ -n "$repo" ]; then
+ cmd="-r ${repo} ${name}"
+ else
+ cmd="${name}"
+ fi
+ if [ -n "$flavor" ]; then
+ cmd="${cmd}-${flavor}"
+ fi
+ if [ -n "$version" ]; then
+ cmd="${cmd}-${version}"
+ fi
+
+ execcmd "add" "$cmd"
+ exit 0
+ fi
+fi
+
+# Debug
+#set +x
diff --git a/cdist/conf/type/__package_pkgng_freebsd/man.text b/cdist/conf/type/__package_pkgng_freebsd/man.text
new file mode 100644
index 00000000..da44da83
--- /dev/null
+++ b/cdist/conf/type/__package_pkgng_freebsd/man.text
@@ -0,0 +1,97 @@
+cdist-type__package_pkgng_freebsd(7)
+==================================
+Jake Guffey
+
+
+NAME
+----
+cdist-type__package_pkgng_freebsd - Manage FreeBSD packages with pkg-ng
+
+
+DESCRIPTION
+-----------
+This type is usually used on FreeBSD to manage packages.
+
+
+REQUIRED PARAMETERS
+-------------------
+None
+
+
+OPTIONAL PARAMETERS
+-------------------
+name::
+ If supplied, use the name and not the object id as the package name.
+
+flavor::
+ If supplied, use to avoid ambiguity.
+
+version::
+ If supplied, use to install a specific version of the package named.
+
+repo::
+ If supplied, use to install the package named from a particular repo.
+
+state::
+ Either "present" or "absent", defaults to "present"
+
+
+BOOLEAN PARAMETERS
+------------------
+upgrade::
+ If supplied, allow upgrading to the latest version of a package.
+
+
+CAVEATS
+-------
+This type requires that repository definitions already exist in /etc/pkg/*.conf.
+Ensure that they exist prior to use of this type with __file.
+
+pkg-ng can't upgrade a package to a specific version. If this type needs to
+upgrade a package, it can only ugprade to the latest available version. If the
+"upgrade" parameter is not given and an upgrade needs to occur, an error will result.
+
+
+MESSAGES
+--------
+install::
+ The package was installed
+remove::
+ The package was removed
+upgrade::
+ The package was upgraded
+exist::
+ The package was already present and thus not installed
+
+
+EXAMPLES
+--------
+
+--------------------------------------------------------------------------------
+# Ensure zsh is installed
+__package_pkgng_freebsd zsh --state present
+
+# Ensure vim is installed, use flavor no_x11
+__package_pkgng_freebsd vim --state present --flavor no_x11
+
+# If you don't want to follow pythonX packages, but always use python
+__package_pkgng_freebsd python --state present --name python2
+
+# Install a package from a particular repository when multiples exist
+__package_pkgng_freebsd bash --state present --repo myrepo
+
+# Remove obsolete package
+__package_pkgng_freebsd puppet --state absent
+--------------------------------------------------------------------------------
+
+
+SEE ALSO
+--------
+- cdist-type(7)
+- cdist-type__package(7)
+
+
+COPYING
+-------
+Copyright \(C) 2014 Jake Guffey. Free use of this software is
+granted under the terms of the GNU General Public License version 3 (GPLv3).
diff --git a/cdist/conf/type/__package_pkgng_freebsd/parameter/boolean b/cdist/conf/type/__package_pkgng_freebsd/parameter/boolean
new file mode 100644
index 00000000..007ead00
--- /dev/null
+++ b/cdist/conf/type/__package_pkgng_freebsd/parameter/boolean
@@ -0,0 +1 @@
+upgrade
\ No newline at end of file
diff --git a/cdist/conf/type/__package_pkgng_freebsd/parameter/optional b/cdist/conf/type/__package_pkgng_freebsd/parameter/optional
new file mode 100644
index 00000000..6e67f838
--- /dev/null
+++ b/cdist/conf/type/__package_pkgng_freebsd/parameter/optional
@@ -0,0 +1,5 @@
+name
+flavor
+version
+repo
+state